var system = server.registerSystem(0, 0);

let last_command_output = null;
function commandCallback(results) {
    last_command_output = results;
};

function execute(command) {
    system.executeCommand(String(command), commandCallback);
};

function copyx(mainObj) {
    let objCopy = {}; // objCopy will store a copy of the mainObj
    let key;

    for (key in mainObj) {
        objCopy[key] = mainObj[key]; // copies each property to the objCopy object
    }
    return objCopy;
}

function chat(text) {
    let execute = system.createEventData("minecraft:display_chat_event");
    execute.data.message = text;
    system.broadcastEvent("minecraft:display_chat_event", execute);
};

function chat_nearest_player(text, blockPos) {
    let cmd = "/tellraw @p[x=" + blockPos.x + ",y=" + blockPos.y + ",z=" + blockPos.z + "] " + `{"rawtext":[{"text":"` + text + `"}]}`
    execute(cmd)
}

system.initialize = function () {
    // system.listenForEvent("minecraft:player_attacked_entity", (eventData) => playerAttackedEntity(eventData))
    
    // system.listenForEvent("worldeditmcpe:client_join", clientEnteredWorld)
    // system.registerEventData("worldeditmcpe:get_hit_result_client", {client_string: "..."})
    
    system.listenForEvent("worldeditmcpe:paint", clientPaintBlocks)
};

system.update = function () {
}

function clientPaintBlocks(eventData) {
    // chat("got paint event")

    let player = eventData.data.client_string

    let main_hand = system.getComponent(player, "minecraft:hand_container").data[0].item
    if (main_hand!="worldeditmcpe:paint_brush") {return}

    let new_player = {
        "__type__": "entity",
        "id": player.id,
        "__unique_id__": {
            "64bit_low": player.__unique_id__['64bit_low'],
            "64bit_high": player.__unique_id__['64bit_high']
        },
        "__identifier__": "minecraft:player"
    }

    player = new_player

    let client_hit_coords = eventData.data.client_hit_coords

    // chat(client_hit_coords.x+' '+client_hit_coords.y+' '+client_hit_coords.z)

    let hotbar_container = system.getComponent(player, "minecraft:hotbar_container").data

    block = String(hotbar_container[8].item).split(':')[1]
    // chat(block)

    let blocks = [
        String(hotbar_container[6].item).split(':')[1],
        String(hotbar_container[7].item).split(':')[1],
        String(hotbar_container[8].item).split(':')[1]
    ]

    if (blocks[0]=="undefined") {
        blocks = [
            blocks[1],
            blocks[2]
        ]
    }
    if (blocks[0]=="undefined") {
        blocks = [
            blocks[1]
        ]
    }
    if (blocks[0]=="undefined") {
        blocks = [
            "air"
        ]
    }

    let relcoords = [
        [-1,-3,-1],
        [-1,-3, 0],
        [-1,-3, 1],
        [ 0,-3,-1],
        [ 0,-3, 0],
        [ 0,-3, 1],
        [ 1,-3,-1],
        [ 1,-3, 0],
        [ 1,-3, 1],

        [-1,-2,-1],
        [-1,-2, 0],
        [-1,-2, 1],
        [ 0,-2,-1],
        [ 0,-2, 0],
        [ 0,-2, 1],
        [ 1,-2,-1],
        [ 1,-2, 0],
        [ 1,-2, 1],

        [-1,-1,-1],
        [-1,-1, 0],
        [-1,-1, 1],
        [ 0,-1,-1],
        [ 0,-1, 0],
        [ 0,-1, 1],
        [ 1,-1,-1],
        [ 1,-1, 0],
        [ 1,-1, 1],

        [-1, 0,-1],
        [-1, 0, 0],
        [-1, 0, 1],
        [ 0, 0,-1],
        [ 0, 0, 0],
        [ 0, 0, 1],
        [ 1, 0,-1],
        [ 1, 0, 0],
        [ 1, 0, 1],

        [-1, 1,-1],
        [-1, 1, 0],
        [-1, 1, 1],
        [ 0, 1,-1],
        [ 0, 1, 0],
        [ 0, 1, 1],
        [ 1, 1,-1],
        [ 1, 1, 0],
        [ 1, 1, 1],

        [ 2,-2,-1],
        [ 2,-2, 0],
        [ 2,-2, 1],
        [ 2,-1,-1],
        [ 2,-1, 0],
        [ 2,-1, 1],
        [ 2, 0,-1],
        [ 2, 0, 0],
        [ 2, 0, 1],

        [-2,-2,-1],
        [-2,-2, 0],
        [-2,-2, 1],
        [-2,-1,-1],
        [-2,-1, 0],
        [-2,-1, 1],
        [-2, 0,-1],
        [-2, 0, 0],
        [-2, 0, 1],

        [-1,-2, 2],
        [ 0,-2, 2],
        [ 1,-2, 2],
        [-1,-1, 2],
        [ 0,-1, 2],
        [ 1,-1, 2],
        [-1, 0, 2],
        [ 0, 0, 2],
        [ 1, 0, 2],

        [-1,-2,-2],
        [ 0,-2,-2],
        [ 1,-2,-2],
        [-1,-1,-2],
        [ 0,-1,-2],
        [ 1,-1,-2],
        [-1, 0,-2],
        [ 0, 0,-2],
        [ 1, 0,-2],
    ]

    for (var b=0; b<relcoords.length; b++) {
        block_coords = [
            client_hit_coords.x+relcoords[b][0],
            client_hit_coords.y+relcoords[b][1],
            client_hit_coords.z+relcoords[b][2]
        ]

        block_pick = blocks[Math.floor(Math.random(  )*blocks.length)]

        execute("/setblock "+block_coords[0]+" "+block_coords[1]+" "+block_coords[2]+" "+block_pick)
    }

    // execute("/fill "+(client_hit_coords.x-1)+" "+(client_hit_coords.y-1-1)+" "+(client_hit_coords.z-1)+" "+(client_hit_coords.x+1)+" "+(client_hit_coords.y+1-1)+" "+(client_hit_coords.z+1)+" "+block+" 0")
    // execute("/fill "+(client_hit_coords.x-1)+" "+(client_hit_coords.y-2-1)+" "+(client_hit_coords.z-1)+" "+(client_hit_coords.x+1)+" "+(client_hit_coords.y+2-1)+" "+(client_hit_coords.z+1)+" "+block+" 0")
    // execute("/fill "+(client_hit_coords.x-2)+" "+(client_hit_coords.y-1-1)+" "+(client_hit_coords.z-1)+" "+(client_hit_coords.x+2)+" "+(client_hit_coords.y+1-1)+" "+(client_hit_coords.z+1)+" "+block+" 0")
    // execute("/fill "+(client_hit_coords.x-1)+" "+(client_hit_coords.y-1-1)+" "+(client_hit_coords.z-2)+" "+(client_hit_coords.x+1)+" "+(client_hit_coords.y+1-1)+" "+(client_hit_coords.z+2)+" "+block+" 0")
}